package tech.jhipster.lite.generator.server.springboot.database.mariadb.infrastructure.primary;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import tech.jhipster.lite.generator.module.domain.properties.JHipsterModulePropertiesDefinition;
import tech.jhipster.lite.generator.module.infrastructure.primary.JHipsterModuleApiDoc;
import tech.jhipster.lite.generator.module.infrastructure.primary.JHipsterModuleResource;
import tech.jhipster.lite.generator.server.springboot.database.mariadb.application.MariaDBApplicationService;

@Configuration
class MariaDBModuleConfiguration {

  public static final String URL_MARIADB_MODULE = "/api/servers/spring-boot/databases/mariadb";

  @Bean
  JHipsterModuleResource mariaDBModule(MariaDBApplicationService applicationService) {
    return JHipsterModuleResource
      .builder()
      .legacyUrl(URL_MARIADB_MODULE)
      .slug("mariadb")
      .propertiesDefinition(JHipsterModulePropertiesDefinition.builder().addBasePackage().addIndentation().addProjectBaseName().build())
      .apiDoc(new JHipsterModuleApiDoc("Spring Boot - Database", "Add MariaDB to project"))
      .factory(applicationService::build);
  }
}
